#!/bin/bash

# Set the problem name to generate correct file names
PROBLEMNAME="incrementalinduction"

# Set this if you want to generate answers.
# g++ -O2 submissions/accepted/sol.cpp -o /tmp/a.out
cp ../../submissions/accepted/torstein_nlogn_py2.py /tmp/sol.py
SOLVER=/tmp/sol.py
MAXN=5000

subfolders=(b_perfect c_circle d_random e_skewed) # (folderA folderB folderC)
for i in ${subfolders[@]}
do
    rm -r $i
    if [ ! -d $i ]
    then
        mkdir $i
    fi
done

COUNT=$(ls a_hand/*.in | wc -l)
generate() {
    ((COUNT++))
    printf -v padCount "%02d" $COUNT
    ./gendata.py -s $COUNT -n $1 -p $2 -o $3 > $DR/${padCount}_n$1_p$2_$3.in
}

echo "Generating dataset 1... (b_perfect)"
DR="b_perfect"

generate 7 0 perfect_noshuffle
generate 8 0 perfect_noshuffle
generate 9 100 perfect_noshuffle
generate 10 100 perfect_noshuffle
generate $MAXN 0 perfect
generate $(($MAXN - 1)) 100 perfect

echo "Generating dataset 2... (c_circle)"
DR="c_circle"

generate 7 50 circle_noshuffle
generate 8 50 circle_noshuffle
generate 9 100 circle_noshuffle
generate 10 100 circle_noshuffle
generate $MAXN 50 circle
generate $(($MAXN - 1)) 50 circle

echo "Generating dataset 3... (d_random)"
DR="d_random"

generate 7 50 random_noshuffle
generate 8 50 random_noshuffle
generate 9 50 random
generate 10 50 random
generate $MAXN 50 random_noshuffle
generate $(($MAXN - 1)) 50 random

echo "Generating dataset 4... (e_skewed)"
DR="e_skewed"

generate 7 80 random_noshuffle
generate 8 80 random_noshuffle
generate 9 20 random
generate 10 20 random
generate $MAXN 80 random
generate $(($MAXN - 1)) 80 random
generate $MAXN 90 random
generate $(($MAXN - 1)) 90 random
generate $MAXN 30 random
generate $(($MAXN - 1)) 30 random
generate $MAXN 95 random
generate $(($MAXN - 1)) 95 random



# generate solutions for all files
if [[ ! -z $SOLVER ]]
then
    for i in ${subfolders[@]}
    do
        for f in $i/*.in
        do
            echo "solving $f"
            $SOLVER < $f > ${f%???}.ans
        done
    done
fi
